// src/binders.ts
function onUpdate(computed, cb, initial = false) {
  if (initial)
    cb(computed.get());
  return computed.observe(() => cb(computed.get()));
}
function input(node, value) {
  const subscription = onUpdate(value, (ref) => node.value = ref.get(), true);
  const listener = () => value.get().set(node.value);
  node.addEventListener("input", listener);
  return {
    destroy() {
      node.removeEventListener("input", listener);
      subscription.revoke();
    }
  };
}
export {
  input
};
