import { Revokable } from './lifecycle';
export interface EventEmitter<EventMap extends {
    [key in string]: unknown[];
}> {
    on<K extends keyof EventMap>(event: K, listener: (...args: EventMap[K]) => void): Revokable;
    trigger<K extends keyof EventMap>(event: K, ...args: EventMap[K]): void;
}
export declare function createEventEmitter<EventMap extends {
    [key in string]: unknown[];
}>(): EventEmitter<EventMap>;
